## ispell-uk 1.7.1

=== Makefile ===
dictdir=`aspell config dict-dir`
datadir=`aspell config data-dir`

VERSION=$(shell cat ./VERSION)

#ISPELLDIR = /usr/lib/ispell
ISPELLDIR = $(shell ispell -d stupidd 2>&1 | sed "s/^[^/]*(\/.*\/)stupidd.*$/\1/")
#MYSPELLDIR = /usr/share/dict/ooo
#MYSPELLDIR = /usr/share/myspell/dicts
MYSPELLDIR=`bin/find_myspell_dir.sh`

DIST = dist

ASPELL_DIST = $(DIST)/aspell-uk-$(VERSION)
ASPELL_DOC_DIR = /usr/share/doc/aspell-uk-$(VERSION)

ISPELL_DIST = $(DIST)/ispell-uk-$(VERSION)
ISPELL_DOC_DIR = /usr/share/doc/ispell-uk-$(VERSION)

MYSPELL_DIST = $(DIST)/myspell-uk-$(VERSION)
MYSPELL_DICT_LST = $(PREFIX)$(MYSPELLDIR)/dictionary.lst
MYSPELL_DOC_DIR = /usr/share/doc/ispell-uk_UA-$(VERSION)

XPI_DIST = $(DIST)/mozilla-xpi-uk-$(VERSION)
OXT_DIST = $(DIST)/openoffice.org-uk-$(VERSION)

UPDATE_VERSION=sed -r "s/@VERSION@/$(VERSION)/g"


#TODO: created this dirs only for particular target
$(shell mkdir -p $(ASPELL_DIST))
$(shell mkdir -p $(ISPELL_DIST))
$(shell mkdir -p $(MYSPELL_DIST))
$(shell mkdir -p $(XPI_DIST)/dictionaries)
$(shell mkdir -p $(OXT_DIST))

KOI8U_SET = src/aspell/koi8-u-nl.cset
KOI8U_MAP = src/aspell/koi8-u-nl.cmap

wordlist_src = src/Dictionary/uk_words.out
affixfile_src = src/Affix/uk_affix.dat

CLEANFILES = uk.rws uk.cwl uk.cwl.gz uk_words.out uk_affix.dat *.bak uk.dat
CLEANFILES += uk.aff uk.dic tmp.header
CLEANFILES += ukrainian.aff ukrainian.hash uk_words.enc uk_words.enc.cnt uk_words.enc.stat ukrainian
CLEANFILES += aspell-uk-*.tgz myspell_uk_UA-*.zip ispell-uk-*.tgz
CLEANFILES += spell*.tgz dist/*.oxt

CLEANDIRS = aspell-uk-* ispell-uk-* dist/*spell* dist/*mozilla* dist/*office*

iconv	= iconv

include encodings.inc

default:	aspell

all: 		aspell myspell mozilla-xpi ooo

packages:	aspell-rpm myspell-rpm myspell-zip mozilla-xpi ooo

install:	install-aspell

install-all:	install-aspell install-myspell

#
# aspell rules
# 
#aspell:		$(ASPELL_DIST)/uk.rws $(ASPELL_DIST)/uk_affix.dat $(ASPELL_DIST)/uk.dat uk.multi ukrainian.alias $(ASPELL_DIST)/ukrainian.kbd
aspell:		$(ASPELL_DIST)/uk.rws $(ASPELL_DIST)/uk.dat src/aspell/uk.multi src/aspell/ukrainian.alias $(ASPELL_DIST)/ukrainian.kbd
	cp -u src/aspell/uk.multi src/aspell/ukrainian.alias $(ASPELL_DIST)

$(ASPELL_DIST)/uk_repl.dat:
	cp -u src/aspell/uk_repl.dat $(ASPELL_DIST)

$(affixfile_src):
	$(MAKE) -C src/Affix

$(wordlist_src):
	$(MAKE) -C src/Dictionary


aspell-tar:	$(DIST)/aspell-uk-$(VERSION).tgz

$(DIST)/aspell-uk-$(VERSION).tgz: aspell
	mkdir -p $(ASPELL_DIST)/doc $(ASPELL_DIST)/misc
	cp -u README Copyright $(ASPELL_DIST)
	cp -u README.uk COPYING.* TODO $(ASPELL_DIST)/doc
	cp -u src/aspell/aspell.net/misc/*.txt $(ASPELL_DIST)/misc
	tar cCvfz $(DIST) --owner=root --group=root $@ aspell-uk-$(VERSION)

aspell-rpm:	srctar
	bin/make_rpm.sh aspell-uk $(VERSION)

install-aspell-dict: aspell
	install -m 0755 -d  $(PREFIX)$(datadir) $(PREFIX)$(dictdir)
	install -m 0644  $(KOI8U_SET) $(KOI8U_MAP) $(PREFIX)$(dictdir)
	install -m 0644  $(ASPELL_DIST)/uk.dat $(PREFIX)$(datadir)
	install -m 0644  $(ASPELL_DIST)/uk.rws $(ASPELL_DIST)/uk.multi $(ASPELL_DIST)/uk_affix.dat $(ASPELL_DIST)/ukrainian.alias $(ASPELL_DIST)/ukrainian.kbd $(PREFIX)$(dictdir)

install-aspell: install-aspell-dict
	install -m 0755 -d  $(PREFIX)$(ASPELL_DOC_DIR)
	install -m 0644	README README.uk Copyright COPYING.* TODO $(PREFIX)$(ASPELL_DOC_DIR)

# dependecies for aspell
uk.cwl:		$(wordlist_src)
	$(iconv) -f $(SOURCE_ENC) -t $(ASPELL_ENC) < $(wordlist_src) | LC_COLLATE=C sort | LC_COLLATE=C word-list-compress c > uk.cwl


uk.cwl.gz:	uk.cwl
	gzip -9 < uk.cwl > uk.cwl.gz

$(ASPELL_DIST)/uk.rws:	$(affixfile_src) $(wordlist_src) $(ASPELL_DIST)/uk_affix.dat $(ASPELL_DIST)/uk.dat $(KOI8U_SET) $(KOI8U_MAP)
	cp -u $(KOI8U_SET) $(KOI8U_MAP) $(ASPELL_DIST)
	cat $(wordlist_src) | $(iconv) -f $(SOURCE_ENC) -t $(ASPELL_ENC) | \
	    aspell --local-data-dir=$(ASPELL_DIST) --lang=uk create master ./$@

$(ASPELL_DIST)/uk_affix.dat:	$(affixfile_src) encodings.inc
	$(iconv) -f $(SOURCE_ENC) -t $(ASPELL_ENC) < $(affixfile_src) > $@

#$(ASPELL_DIST)/uk_words.out:	$(wordlist_src) encodings.inc
#	$(iconv) -f $(SOURCE_ENC) -t $(ASPELL_ENC) < $(wordlist_src) > $@

$(ASPELL_DIST)/uk.dat:		src/aspell/uk.dat.templ encodings.inc
	sed "s/^data-encoding.*$$/data-encoding   $(ASPELL_ENC_NAME)/" < src/aspell/uk.dat.templ > $@

# *.kbd file should be always in UTF-8
$(ASPELL_DIST)/ukrainian.kbd:	src/aspell/ukrainian.kbd
	cp -u $< $@

# official aspell.net package

aspell.net:
	wget ftp://ftp.gnu.org/gnu/aspell/aspell-lang-20040810.tar.bz2
	aspell-lang-20040810/aspell-lang

#
# myspell rules
#
hunspell:	myspell


myspell: 	$(MYSPELL_DIST)/uk_UA.aff $(MYSPELL_DIST)/uk_UA.dic

install-myspell-dict:	myspell
	install -m 0755 -d  $(PREFIX)$(MYSPELLDIR)
	install -m 0644	$(MYSPELL_DIST)/uk_UA.aff $(MYSPELL_DIST)/uk_UA.dic $(PREFIX)$(MYSPELLDIR)

install-myspell:	install-myspell-dict
	install -m 0755 -d  $(PREFIX)$(MYSPELL_DOC_DIR)
	install -m 0644	src/myspell/README* $(PREFIX)$(MYSPELL_DOC_DIR)
	if [[ ! -f "$(MYSPELL_DICT_LST)" ]] || \
		! grep -q "^DICT[ \t]*uk[ \t]*UA[ \t]*uk_UA\$$" $(MYSPELL_DICT_LST); \
	then \
		echo "DICT uk UA uk_UA" >> $(MYSPELL_DICT_LST); \
	fi

myspell-zip:	$(DIST)/myspell-uk_UA-$(VERSION).zip

myspell-rpm:	srctar
	bin/make_rpm.sh myspell-uk $(VERSION)

$(DIST)/myspell-uk_UA-$(VERSION).zip: myspell
	rm -f $@
	zip -j $@ $(MYSPELL_DIST)/uk_UA.aff $(MYSPELL_DIST)/uk_UA.dic src/myspell/README*

# myspell dependencies
$(MYSPELL_DIST)/uk_UA.aff:	$(affixfile_src) src/myspell/myspell.header encodings.inc
	mkdir -p $(MYSPELL_DIST)
	sed s/xxENCODINGxx/UTF-8/ < src/myspell/myspell.header > tmp.header
	cat tmp.header $(affixfile_src) | $(iconv) -f $(SOURCE_ENC) -t $(MYSPELL_ENC) > $@
	-rm tmp.header

$(MYSPELL_DIST)/uk_UA.dic:	$(wordlist_src) encodings.inc
	wc -l < $(wordlist_src) > $@
	cat $(wordlist_src) | $(iconv) -f $(SOURCE_ENC) -t $(MYSPELL_ENC) >> $@

mozilla-xpi:	myspell
	mkdir -p $(XPI_DIST)/dictionaries
	cp $(MYSPELL_DIST)/uk_UA.aff $(XPI_DIST)/dictionaries/uk-UA.aff
	cp $(MYSPELL_DIST)/uk_UA.dic $(XPI_DIST)/dictionaries/uk-UA.dic
	cat src/mozilla/README_uk_UA.txt.header src/myspell/README_uk_UA.txt > $(XPI_DIST)/README_uk_UA.txt
	cp COPYING.LGPL $(XPI_DIST)/
	cp src/mozilla/*.png $(XPI_DIST)/
	$(UPDATE_VERSION) < src/mozilla/install.js > $(XPI_DIST)/install.js
	$(UPDATE_VERSION) < src/mozilla/install.rdf > $(XPI_DIST)/install.rdf
	cd $(XPI_DIST) && zip -r ../ukrainian_dictionary-$(VERSION)-mozilla.xpi * && cd ..
#	cp src/mozilla/install* $(XPI_DIST)

ooo:	myspell
	mkdir -p $(OXT_DIST)
	cp -r src/openoffice.org/* $(OXT_DIST)
	$(UPDATE_VERSION) < src/openoffice.org/description.xml > $(OXT_DIST)/description.xml
	cp $(MYSPELL_DIST)/uk_UA.aff $(OXT_DIST)/uk_UA/
	cp $(MYSPELL_DIST)/uk_UA.dic $(OXT_DIST)/uk_UA/
	cp src/myspell/README_uk_UA.txt $(OXT_DIST)/uk_UA/
	cp src/thesaurus/th_uk_UA.dat $(OXT_DIST)/uk_UA/
	bin/th_gen_idx.pl < src/thesaurus/th_uk_UA.dat > $(OXT_DIST)/uk_UA/th_uk_UA.idx
	-rm *.oxt
	cd $(OXT_DIST) && zip -r ../dict-uk_UA-$(VERSION).oxt * && cd ..

# for myspell engine (Firefox <=2, Thunderbird <=2...)
mozilla-xpi-old:	myspell
	grep -v "IGNORE" $(MYSPELL_DIST)/uk_UA.aff | sed "s/$(MYSPELL_ENC_NAME)/KOI8-U/" | iconv -f $(MYSPELL_ENC) -t koi8-u > $(XPI_DIST)/dictionaries/uk-UA.aff
	cat $(MYSPELL_DIST)/uk_UA.dic | iconv -f $(MYSPELL_ENC) -t koi8-u > $(XPI_DIST)/dictionaries/uk-UA.dic
	cat src/mozilla/old/README_uk_UA.txt.header src/myspell/README_uk_UA.txt > $(XPI_DIST)/dictionaries/README_uk_UA.txt
	cp COPYING.LGPL $(XPI_DIST)/dictionaries/
	cp src/mozilla/old/install* $(XPI_DIST)
	cd $(XPI_DIST) && zip -r ukrainian_dictionary-$(VERSION)-mozilla-old.xpi dictionaries install.* && cd ..

#
# ispell rules
#
ispell:		$(ISPELL_DIST)/ukrainian.aff $(ISPELL_DIST)/ukrainian.hash

install-ispell-dict:	ispell
	install -m 0755 -d $(PREFIX)$(ISPELLDIR)
	install -m 0644 $(ISPELL_DIST)/ukrainian.aff $(ISPELL_DIST)/ukrainian.hash $(PREFIX)$(ISPELLDIR)

install-ispell:		install-ispell-dict
	install -m 0755 -d  $(PREFIX)$(ISPELL_DOC_DIR)
	install -m 0644	src/ispell/README Copyright COPYING.* $(PREFIX)$(ISPELL_DOC_DIR)

ispell-tar:	$(DIST)/ispell-uk-$(VERSION).tgz

$(DIST)/ispell-uk-$(VERSION).tgz: ispell
	mkdir -p $(ISPELL_DIST)/doc
	cp -u src/ispell/README Copyright COPYING.* $(ISPELL_DIST)/doc
	tar cCvfz $(DIST) --owner=root --group=root $@ --exclude='*.enc*' ispell-uk-$(VERSION)

ispell-rpm:	srctar
	bin/make_rpm.sh ispell-uk $(VERSION)

# dependencies for ispell
$(ISPELL_DIST)/ukrainian.aff:	$(affixfile_src) bin/affconv.pl src/ispell/ispell.header encodings.inc
	(cat src/ispell/ispell.header && grep -v "REP" $(affixfile_src) | perl bin/affconv.pl ) | $(iconv) -f $(SOURCE_ENC) -t $(ISPELL_ENC) > $@

$(ISPELL_DIST)/uk_words.enc:	$(wordlist_src) encodings.inc
	$(iconv) -f $(SOURCE_ENC) -t $(ISPELL_ENC) < $(wordlist_src) > $@

$(ISPELL_DIST)/ukrainian.hash:	$(ISPELL_DIST)/uk_words.enc $(ISPELL_DIST)/ukrainian.aff
	buildhash $(ISPELL_DIST)/uk_words.enc $(ISPELL_DIST)/ukrainian.aff $(ISPELL_DIST)/ukrainian.hash

# wordlist rules
#
ukrainian:	$(wordlist_src) aspell
	# XXX need to sorth this somehow (and do nont use one more locale)
	iconv -f $(SOURCE_ENC) -t $(ASPELL_ENC) < $(wordlist_src) |\
		aspell expand --encoding=$(ASPELL_ENC_NAME) \
		--local-data-dir=$(ASPELL_DIST) --lang=uk | \
		tr -s ' ' '\n' | sed '/^$$/d' > $@ 

install-wordlist: ukrainian
	install -m 0755 -d $(PREFIX)/usr/share/dict
	install -m 0644 ukrainian $(PREFIX)/usr/share/dict

# common rules
#
$(affixfile_src): affix-dir
$(wordlist_src): dictionary-dir

affix-dir:
	$(MAKE) -C src/Affix

dictionary-dir:
	$(MAKE) -C src/Dictionary

# regression test
#
regtest:	aspell $(wordlist_src)
	$(MAKE) -C test regtest

regtestroll:
	$(MAKE) -C test regtestroll


srctar: clean
	tar cfz $(DIST)/spell-uk-$(VERSION).tgz --exclude=test/all* --exclude=dist/*spell* --exclude=dist/*openoffice* --exclude=dist/*.oxt --exclude=*.old --exclude=src_text --exclude=CVS --exclude=--exclude=.* --exclude=tools *
	mkdir -p $(DIST)/spell-uk-$(VERSION)
	tar xCfz $(DIST)/spell-uk-$(VERSION) $(DIST)/spell-uk-$(VERSION).tgz
	tar cCfz $(DIST) $(DIST)/spell-uk-$(VERSION).tgz --owner=root --group=root spell-uk-$(VERSION)
	rm -rf $(DIST)/spell-uk-$(VERSION) 


# cleaning
#
clean:
	rm -f $(CLEANFILES)
	rm -rf $(CLEANDIRS)
	$(MAKE) -C src/Affix clean
	$(MAKE) -C src/Dictionary clean
	$(MAKE) -C test clean


.PHONY: all regtest regtestroll clean aspell myspell ispell 
.PHONY: install install-all install-aspell install-myspell install-myspell-dict install-ispell install-wordlist 
.PHONY: aspell-tar myspell-zip ispell-tar srctar affix-dir dictionary-dir

=== test/Makefile ===
include ../encodings.inc

LC_ALL	= LC_ALL=uk_UA.$(SOURCE_ENC)
sort	= $(LC_ALL) sort
spcr	= tr ' ' '\n'

CLEANFILES	= *.lst *.srt *.diff *.dups *.nodups
DISTCLEANFILES	= *.old

wordlist_src = ../src/Dictionary/uk_words.out
iconv	= iconv

VERSION=$(shell cat ../VERSION)
DIST = ../dist
ASPELL_DIST = $(DIST)/aspell-uk-$(VERSION)
ASPELL_DICT = $(shell pwd)/../dist/aspell-uk-$(VERSION)
MYSPELL_DICT = $(shell pwd)/../dist/myspell-uk-$(VERSION)/uk_UA | grep "[а-яіїєґ]"


#LIST_CMD=LC_ALL=uk_UA.UTF-8 aspell list -l uk --dict-dir=$(ASPELL_DICT)
LIST_CMD=hunspell -l -d $(MYSPELL_DICT)

all: 	regtest-aspell

#	cat $(wordlist_src) | $(LC_ALL) aspell expand -l uk --local-data-dir=../ > all_aspell.lst
all_aspell_lst:
	make -C ..
	cat $(wordlist_src) | aspell expand -l uk --local-data-dir=$(ASPELL_DIST) --encoding=$(SOURCE_ENC) > all_aspell.lst

regtest:	all_aspell_lst
	cat all_aspell.lst | $(spcr) | $(sort) > all_aspell.srt
	cat all_aspell.srt | uniq > all_aspell.srt.nodups
	cat all_aspell.srt | uniq -d -c > all_aspell.srt.dups
	-diff all_aspell.srt.nodups.old all_aspell.srt.nodups > all_aspell.srt.nodups.diff
	-diff all_aspell.srt.dups.old all_aspell.srt.dups > all_aspell.srt.dups.diff


regtestroll:
	-[ -f all_aspell.srt.nodups ] && mv -f all_aspell.srt.nodups all_aspell.srt.nodups.old
	-[ -f all_aspell.srt.dups ] && mv -f all_aspell.srt.dups all_aspell.srt.dups.old
	-[ -f Malyk.lst ] && mv -f Malyk.lst Malyk.lst.old
	-[ -f ZN.lst ] && mv -f ZN.lst ZN.lst.old
	-[ -f KDE.lst ] && mv -f KDE.lst KDE.lst.old
	-[ -f ukr_lit.lst ] && mv -f ukr_lit.lst ukr_lit.lst.old

text:
	cat src_text/Malyk.txt | $(LIST_CMD) | LC_ALL=uk_UA.UTF-8 sort | LC_ALL=uk_UA.UTF-8 uniq -i > Malyk.lst
	cat src_text/ZN.txt | $(LIST_CMD) | LC_ALL=uk_UA.UTF-8 sort | LC_ALL=uk_UA.UTF-8 uniq -i > ZN.lst
	cat src_text/KDE.po | sed "s/&//g" | sed "s/’/'/g" | sed -r "s/\\[a-z]//g" | $(LIST_CMD) | LC_ALL=uk_UA.UTF-8 sort | LC_ALL=uk_UA.UTF-8 uniq -i > KDE.lst
	cat src_text/ukr_lit.txt | sed "s/’/'/g" | $(LIST_CMD) | LC_ALL=uk_UA.UTF-8 sort | LC_ALL=uk_UA.UTF-8 uniq -i > ukr_lit.lst

text_regtest:	text
	-diff Malyk.lst.old Malyk.lst > Malyk.diff
	-diff ZN.lst.old ZN.lst > ZN.diff
	-diff KDE.lst.old KDE.lst > KDE.diff
	-diff ukr_lit.lst.old ukr_lit.lst > ukr_lit.diff
	

reverse:	all_aspell.srt
	 iconv -f UTF-8 -t KOI8-U all_aspell.srt | LC_ALL=uk_UA.KOI8-U perl -ne 'print scalar reverse $$_;' | LANG=uk_UA.KOI8-U sort | LC_ALL=uk_UA.KOI8-U perl -ne 'print scalar reverse $$_;' | iconv -f KOI8-U -t UTF-8 > all_spell.reverse.lst


clean:
	rm -f $(CLEANFILES)


distclean:
	rm -f $(CLEANFILES) $(DISTCLEANFILES)


.PHONY: all regtest regtestroll clean clean_all all_spell_lst

=== src/Affix/Makefile ===
include ../../encodings.inc
reverse_verbs = ../../bin/verb_reverse.pl


affixfile = uk_affix.dat
src_affixfiles = uk.REP uk.aff.ADJ uk.aff.NOUN uk.aff.VERB uk.aff.VERB_REV uk.aff.DIEPR uk.aff.DIEPR_REV uk.aff.PREFIX

CLEANFILES = $(affixfile) uk.aff.VERB_REV


all: $(affixfile)


$(affixfile): $(src_affixfiles)
	cat $(src_affixfiles) | sed 's/#.*$$//g; s/	/ /g; s/ \+/ /g; /^ *$$/d' > $@

uk_affix.tag: $(src_affixfiles)
	cat $(src_affixfiles) | grep -Ev "^#|^REP" | sed 's/	/ /g; s/ \+/ /g; /^ *$$/d' > $@

uk.aff.VERB_REV: uk.aff.VERB $(reverse_verbs)
	$(reverse_verbs) < uk.aff.VERB > uk.aff.VERB_REV

uk.aff.DIEPR_REV: uk.aff.DIEPR $(reverse_verbs)
	$(reverse_verbs) < uk.aff.DIEPR > uk.aff.DIEPR_REV

clean:
	rm -f $(CLEANFILES) 


.PHONY: all clean

=== src/Dictionary/Makefile ===
include ../../encodings.inc
include dictionaries.mk.inc


spcr	   =	tr -s ' ' '\n'
LC_ALL	   =	LC_ALL=$(LOCALE)
sort	   =	$(LC_ALL) sort

dict	   = 	$(INDICT)
dictionary =	uk_words.out

CLEANFILES =	uk_words.out *.tmp *.old *.bak *.tag


all:	uk_words.out


uk_words.out: $(dict)
	cat $(SPACED) | sed -r "s/ [^ ]+ [a-z].*$$//g" | $(LC_ALL) grep -vE '^[#[:space:]]' | $(spcr) > spaced.tmp
	cat $(TAGGED) | $(LC_ALL) grep -vE "^ *#|^ *$$" | awk -F " " '{ print $$1}' | sort -u >> spaced.tmp
	cat $(NOTSPACED) spaced.tmp | grep -vE "[-]$$" | sed -r "s/[<>]//g" | $(sort) > $@
	rm -f spaced.tmp

uk_words.tag: $(dict) tags.lst
	cat $(SPACED) | grep -vE " [^ ]+ [a-z].*$$" | $(LC_ALL) grep -vE "^[#[:space:]]" | $(spcr) > spaced.tmp
	cat $(SPACED) | grep -E " [^ ]+ [a-z].*$$" | $(LC_ALL) grep -vE "^[#[:space:]]" >> spaced.tmp
	cat $(TAGGED) | $(LC_ALL) grep -vE "^ *#|^ *$$" | awk -F " " '{ if ($$2 != "" && $$3 == "") print $$1,$$1,$$2; else print $$0; }' | sort -u >> spaced.tmp
	grep "/" twisters.lst | sed -r "s/ .*$$//" | awk '{ print $$0 " :bad" }' >> spaced.tmp
	cat verify.lst >> spaced.tmp
	cat $(NOTSPACED) spaced.tmp tags.lst | sed -r "s/-$$//" | sed -r "s/^[А-ЯІЇЄҐ]{2,}$$/\0 \0 noun:nv/" | $(sort) > $@
	rm -f spaced.tmp

wc:     uk_words.out
#	echo `cat uk_words.out | wc -l` + `grep -E "W|Z|A.*B|I.*J|K.*L|M.*N|Y|X" uk_words.out | wc -l` | bc
	sed -r "s/[WZYXOP]|A.*B|I.*J|K.*L|M.*N/\n/g" uk_words.out | wc -l

sort:
	@for ff in $(SORTED) ; do \
	    (mv -f $$ff $$ff.old && \
	    $(sort) < $$ff.old | uniq > $$ff && \
	    rm -f $$ff.old) ; \
	done

# helper targets

stat:	uk_words.out
	grep "/" uk_words.out | LC_ALL=uk_UA.UTF-8 sed "s/^.*\([а-я'][а-я]\/[A-Za-z]\).*$$/\1/" | sort | uniq -c > uk_words2.stat
	$(LC_ALL) grep -E "[а-я']{4,}/" uk_words.out | $(LC_ALL) sed "s/^.*\([а-я'][а-я'][а-я]\/[A-Za-z]\).*$$/\1/" | sort | uniq -c > uk_words3.stat
	$(LC_ALL) grep -E "[а-я']{4,}/" uk_words.out | $(LC_ALL) sed "s/^.*\([а-я'][а-я'][а-я]\/[A-Za-z]\+\)$$/\1/" | sort | uniq -c > uk_words3f.stat


bad:	all
	-rm -f uk_words.bad
	-$(LC_ALL) grep -E "[EF].*[CD]|[CD].*[EF]" uk_words.out > uk_words.bad
	-$(LC_ALL) grep -E "[AB].*[IJ]|[IJ].*[AB]" uk_words.out >> uk_words.bad

dups:	all
	-rm -f uk_words.dups
	-sed "s/[/A-Z]*//gi" uk_words.out | $(LC_ALL) sort | uniq -d > uk_words.dups
	-sed "s/[/A-Z]*//gi" uk_words.out | $(LC_ALL) sed "s/[еє]/.e./ig" | $(LC_ALL) sort | uniq -d > uk_words.dups_e
	-sed "s/[/A-Z]*//gi" uk_words.out | $(LC_ALL) sed "s/[гґ]/.г./ig" | $(LC_ALL) sort | uniq -d > uk_words.dups_g
	-sed "s/[/A-Z]*//gi" uk_words.out | $(LC_ALL) sed "s/[иі]/.и./ig" | $(LC_ALL) sort | uniq -d > uk_words.dups_y

adj:	all
	-rm -f uk_words.adj
	-grep "аючий" uk_words.out > uk_words.adj


clean:
	rm -f $(CLEANFILES)

.PHONY: clean all sort

=== debian/changelog ===
ispell-uk (1.7.1-2) unstable; urgency=medium

  [ gregor herrmann ]
  * Fix "FTBFS: The encoding pragma is no longer supported at
    ../../bin/verb_reverse.pl line 12.":
    Add perl5.26-encoding.patch: replace "use encoding" with "use open" in
    perl helper scripts. Additionally run ispell build in debian/rules under
    C.UTF-8. (Closes: #871349)

  [ Євгеній Мещеряков ]
  * Add debian/gbp.conf with correct branch for this package (1.7.1-support)

 -- Євгеній Мещеряков <eugen@debian.org>  Tue, 15 Aug 2017 23:42:55 +0200

ispell-uk (1.7.1-1) unstable; urgency=medium

  * New upstream release
  * Update debian/copyright
  * Use class:Depends variables provided by dictionaries-common-dev

 -- Євгеній Мещеряков <eugen@debian.org>  Wed, 30 Apr 2014 21:59:38 +0200

ispell-uk (1.7.0-1) unstable; urgency=medium

  * The "Euromaidan" release
  * New upstream release
  * Standards-Version 3.9.5 — no changes required

 -- Євгеній Мещеряков <eugen@debian.org>  Wed, 19 Feb 2014 21:29:55 +0100

=== debian/control ===
Source: ispell-uk
Section: text
Priority: optional
Maintainer: Євгеній Мещеряков <eugen@debian.org>
Build-Depends: debhelper (>= 7.0.0), dictionaries-common-dev (>= 1.22.4~), ispell (>= 3.3.02~), aspell (>= 0.60.3-3), locales (>> 2)
Standards-Version: 3.9.5
Homepage: http://ispell-uk.sourceforge.net
Vcs-Git: git://git.debian.org/collab-maint/ispell-uk.git
Vcs-Browser: http://git.debian.org/?p=collab-maint/ispell-uk.git

Package: iukrainian
Architecture: any
Depends: ${ispell:Depends}, ${misc:Depends}
Suggests: wukrainian
Provides: ispell-dictionary
Description: Ukrainian dictionary for ispell
 This is a Ukrainian dictionary, to be used with the ispell program.

Package: wukrainian
Architecture: all
Depends: ${wordlist:Depends}, ${misc:Depends}
Provides: wordlist
Description: Ukrainian dictionary words for /usr/share/dict
 This package provides the file /usr/share/dict/ukrainian
 containing a list of Ukrainian words.  This list can be used by
 spelling checkers, and by programs such as look(1).

Package: myspell-uk
Architecture: all
Depends: dictionaries-common (>= 1.11.2~), ${misc:Depends}
Provides: myspell-dictionary, myspell-dictionary-uk
Suggests: libreoffice
Description: Ukrainian dictionary for myspell
 This is the Ukrainian dictionary for use with the myspell
 spellchecker which is currently used within OpenOffice.org and the
 mozilla spellchecker.

Package: aspell-uk
Architecture: all
Depends: ${aspell:Depends}, ${misc:Depends}
Provides: aspell-dictionary
Description: Ukrainian dictionary for GNU Aspell
 This package contains all the required files to add support for the
 Ukrainian language to the GNU Aspell spell checker.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# This has to be exported to make some magic below work.
export DH_OPTIONS

LC_ALL = C
LOCALE_PATH = $(CURDIR)/debian/locale
export LC_ALL LOCALE_PATH

locale: locale-stamp
locale-stamp:
	mkdir $(LOCALE_PATH)
	localedef -i uk_UA -f KOI8-U $(LOCALE_PATH)/uk_UA
	localedef -i uk_UA -f UTF-8 $(LOCALE_PATH)/uk_UA.UTF-8
	touch locale-stamp
	
build: build-arch build-indep

build-arch: build-arch-stamp
build-arch-stamp: locale
	LC_ALL=C.UTF-8 LOCPATH=$(LOCALE_PATH) $(MAKE) ispell
	touch build-arch-stamp

build-indep: build-indep-stamp
build-indep-stamp: locale
	LOCPATH=$(LOCALE_PATH) $(MAKE) ASPELL_ENC=utf-8 ASPELL_ENC_NAME=utf-8 myspell aspell uk.cwl.gz ukrainian
	touch build-indep-stamp

clean:
	dh clean
	rm -rf debian/locale

install: install-indep install-arch
install-indep: build-indep
	dh_testdir
	dh_testroot
	dh_prep -i 
	dh_installdirs -i
	cp dist/myspell-uk-*/uk_UA.aff debian/myspell-uk/usr/share/hunspell
	cp dist/myspell-uk-*/uk_UA.dic debian/myspell-uk/usr/share/hunspell
	LOCPATH=$(LOCALE_PATH) LC_ALL=uk_UA.UTF-8 sort -d ukrainian | uniq > debian/wukrainian/usr/share/dict/ukrainian
	cp uk.cwl.gz debian/aspell-uk/usr/share/aspell
	dh_install --sourcedir=dist/aspell-uk-* -paspell-uk

install-arch: build-arch
	dh_testdir
	dh_testroot
	dh_prep -s 
	dh_installdirs -s
	dh_install --sourcedir=dist/ispell-uk-* -piukrainian

binary-arch: install-arch
	dh_testdir
	dh_testroot
	dh_installchangelogs -a
	dh_installdocs -a
	installdeb-ispell -p iukrainian
	dh_link -a
	dh_compress -a
	dh_fixperms -a
	dh_installdeb -a
	dh_gencontrol -a
	dh_md5sums -a
	dh_builddeb -a

binary-indep: install-indep
	dh_testdir
	dh_testroot
	dh_installchangelogs -i
	dh_installdocs -i
	installdeb-myspell -p myspell-uk
	installdeb-wordlist -p wukrainian
	installdeb-aspell -p aspell-uk
	dh_link -i
	dh_compress -i
	dh_fixperms -i
	dh_installdeb -i
	dh_gencontrol -i
	dh_md5sums -i
	dh_builddeb -i

binary: binary-arch binary-indep
.PHONY: build build-arch build-indep clean binary-indep binary-arch binary install install-indep install-arch locale

## ispell-uk 1.8.0%2Bdfsg

=== debian/rules ===
#!/usr/bin/make -f

LC_ALL = C.UTF-8
LOCALE_PATH = $(CURDIR)/debian/locale
export LC_ALL LOCALE_PATH

%:
	dh $@

override_dh_auto_configure:
	mkdir $(LOCALE_PATH)
	localedef -i uk_UA -f UTF-8 $(LOCALE_PATH)/uk_UA.UTF-8
	
override_dh_auto_build:
	LOCPATH=$(LOCALE_PATH) $(MAKE) ASPELL_ENC=utf-8 ASPELL_ENC_NAME=utf-8 myspell aspell uk.cwl.gz ukrainian

override_dh_clean:
	dh_clean $(LOCALE_PATH)/

override_dh_auto_install:
	cp dist/myspell-uk-*/uk_UA.aff debian/myspell-uk/usr/share/hunspell
	cp dist/myspell-uk-*/uk_UA.dic debian/myspell-uk/usr/share/hunspell
	LOCPATH=$(LOCALE_PATH) LC_ALL=uk_UA.UTF-8 sort -d ukrainian | uniq > debian/wukrainian/usr/share/dict/ukrainian
	cp uk.cwl.gz debian/aspell-uk/usr/share/aspell

override_dh_install:
	dh_install --sourcedir=dist/aspell-uk-*

execute_after_dh_install:
	installdeb-myspell -p myspell-uk
	installdeb-wordlist -p wukrainian
	installdeb-aspell -p aspell-uk

## ispell-uk 1.8.0+dfsg

=== Makefile ===
--- 
+++ 
@@ -52,7 +52,7 @@
 
 include encodings.inc
 
-default:	aspell
+default:	myspell
 
 all: 		aspell myspell mozilla-xpi ooo
 
@@ -67,15 +67,16 @@
 # 
 #aspell:		$(ASPELL_DIST)/uk.rws $(ASPELL_DIST)/uk_affix.dat $(ASPELL_DIST)/uk.dat uk.multi ukrainian.alias $(ASPELL_DIST)/ukrainian.kbd
 aspell:		$(ASPELL_DIST)/uk.rws $(ASPELL_DIST)/uk.dat src/aspell/uk.multi src/aspell/ukrainian.alias $(ASPELL_DIST)/ukrainian.kbd
+	echo "aspell is not actively maintained any more, please switch to hunspell"
 	cp -u src/aspell/uk.multi src/aspell/ukrainian.alias $(ASPELL_DIST)
 
 $(ASPELL_DIST)/uk_repl.dat:
 	cp -u src/aspell/uk_repl.dat $(ASPELL_DIST)
 
-$(affixfile_src):
+affix-dir:
 	$(MAKE) -C src/Affix
 
-$(wordlist_src):
+dictionary-dir:
 	$(MAKE) -C src/Dictionary
 
 
@@ -164,13 +165,13 @@
 	zip -j $@ $(MYSPELL_DIST)/uk_UA.aff $(MYSPELL_DIST)/uk_UA.dic src/myspell/README*
 
 # myspell dependencies
-$(MYSPELL_DIST)/uk_UA.aff:	$(affixfile_src) src/myspell/myspell.header encodings.inc
+$(MYSPELL_DIST)/uk_UA.aff:	affix-dir src/myspell/myspell.header encodings.inc
 	mkdir -p $(MYSPELL_DIST)
 	sed s/xxENCODINGxx/UTF-8/ < src/myspell/myspell.header > tmp.header
 	cat tmp.header $(affixfile_src) | $(iconv) -f $(SOURCE_ENC) -t $(MYSPELL_ENC) > $@
 	-rm tmp.header
 
-$(MYSPELL_DIST)/uk_UA.dic:	$(wordlist_src) encodings.inc
+$(MYSPELL_DIST)/uk_UA.dic:	dictionary-dir encodings.inc
 	wc -l < $(wordlist_src) > $@
 	cat $(wordlist_src) | $(iconv) -f $(SOURCE_ENC) -t $(MYSPELL_ENC) >> $@
 
@@ -210,7 +211,10 @@
 #
 # ispell rules
 #
-ispell:		$(ISPELL_DIST)/ukrainian.aff $(ISPELL_DIST)/ukrainian.hash
+#ispell:		$(ISPELL_DIST)/ukrainian.aff $(ISPELL_DIST)/ukrainian.hash
+ispell:
+	@echo "FATAL: ispell is not supported any more, please use hunspell" >&2
+	@/bin/false
 
 install-ispell-dict:	ispell
 	install -m 0755 -d $(PREFIX)$(ISPELLDIR)
@@ -253,20 +257,9 @@
 	install -m 0755 -d $(PREFIX)/usr/share/dict
 	install -m 0644 ukrainian $(PREFIX)/usr/share/dict
 
-# common rules
-#
-$(affixfile_src): affix-dir
-$(wordlist_src): dictionary-dir
-
-affix-dir:
-	$(MAKE) -C src/Affix
-
-dictionary-dir:
-	$(MAKE) -C src/Dictionary
-
 # regression test
 #
-regtest:	aspell $(wordlist_src)
+regtest:
 	$(MAKE) -C test regtest
 
 regtestroll:
@@ -274,7 +267,7 @@
 
 
 srctar: clean
-	tar cfz $(DIST)/spell-uk-$(VERSION).tgz --exclude=test/all* --exclude=dist/*spell* --exclude=dist/*openoffice* --exclude=dist/*.oxt --exclude=*.old --exclude=src_text --exclude=CVS --exclude=--exclude=.* --exclude=tools *
+	tar cfz $(DIST)/spell-uk-$(VERSION).tgz --exclude=test --exclude=dist/*spell* --exclude=dist/*openoffice* --exclude=dist/*.oxt --exclude=*.old --exclude=src_text --exclude=CVS --exclude=--exclude=.* --exclude=tools *
 	mkdir -p $(DIST)/spell-uk-$(VERSION)
 	tar xCfz $(DIST)/spell-uk-$(VERSION) $(DIST)/spell-uk-$(VERSION).tgz
 	tar cCfz $(DIST) $(DIST)/spell-uk-$(VERSION).tgz --owner=root --group=root spell-uk-$(VERSION)

=== src/Affix/Makefile ===
--- 
+++ 
@@ -12,7 +12,7 @@
 
 
 $(affixfile): $(src_affixfiles)
-	cat $(src_affixfiles) | sed 's/#.*$$//g; s/	/ /g; s/ \+/ /g; /^ *$$/d' > $@
+	cat $(src_affixfiles) | sed 's/[\t ]*#.*$$//g; s/	/ /g; s/ \+/ /g; /^ *$$/d' > $@
 
 uk_affix.tag: $(src_affixfiles)
 	cat $(src_affixfiles) | grep -Ev "^#|^REP" | sed 's/	/ /g; s/ \+/ /g; /^ *$$/d' > $@

=== src/Dictionary/Makefile ===
--- 
+++ 
@@ -10,29 +10,26 @@
 dictionary =	uk_words.out
 
 CLEANFILES =	uk_words.out *.tmp *.old *.bak *.tag
-
+BAD_FLAG_RE="(/[IJ].*[OP]|[AB][^IJ]*[QR]|/[^AIKM].*[OQ0]|JH?O|BH?R|AG?Q|IG?O)"
+BAD_TAGS_RE="nontran|:[а-яіїєґ]|/.* [^:^]|[OPGHQR].* :perf|/.* [a-z]|[A-T].* :([^ipbr]|in)|[A-T][^ ]*$$"
 
 all:	uk_words.out
 
 
-uk_words.out: $(dict)
+uk_words.out: $(dict) Makefile
 	cat $(SPACED) | sed -r "s/ [^ ]+ [a-z].*$$//g" | $(LC_ALL) grep -vE '^[#[:space:]]' | $(spcr) > spaced.tmp
 	cat $(TAGGED) | $(LC_ALL) grep -vE "^ *#|^ *$$" | awk -F " " '{ print $$1}' | sort -u >> spaced.tmp
 	cat $(NOTSPACED) spaced.tmp | grep -vE "[-]$$" | sed -r "s/[<>]//g" | $(sort) > $@
 	rm -f spaced.tmp
+	@(grep -E $(BAD_FLAG_RE) $@ && echo "ERROR: Bad flag combinations exist!" && /bin/false) || /bin/true
 
-uk_words.tag: $(dict) tags.lst
-	cat $(SPACED) | grep -vE " [^ ]+ [a-z].*$$" | $(LC_ALL) grep -vE "^[#[:space:]]" | $(spcr) > spaced.tmp
-	cat $(SPACED) | grep -E " [^ ]+ [a-z].*$$" | $(LC_ALL) grep -vE "^[#[:space:]]" >> spaced.tmp
-	cat $(TAGGED) | $(LC_ALL) grep -vE "^ *#|^ *$$" | awk -F " " '{ if ($$2 != "" && $$3 == "") print $$1,$$1,$$2; else print $$0; }' | sort -u >> spaced.tmp
-	grep "/" twisters.lst | sed -r "s/ .*$$//" | awk '{ print $$0 " :bad" }' >> spaced.tmp
-	cat verify.lst >> spaced.tmp
-	cat $(NOTSPACED) spaced.tmp tags.lst | sed -r "s/-$$//" | sed -r "s/^[А-ЯІЇЄҐ]{2,}$$/\0 \0 noun:nv/" | $(sort) > $@
-	rm -f spaced.tmp
+uk_words.tag: $(dict) tags.lst Makefile
+	../../bin/tag/mk_tagged_wordlist.py $(dict) tags.lst twisters.lst verify.lst rare.lst | $(sort) > $@
+	@(grep -E $(BAD_TAGS_RE) $@ && echo "ERROR: Bad tags exist!" && /bin/false) || /bin/true
 
 wc:     uk_words.out
 #	echo `cat uk_words.out | wc -l` + `grep -E "W|Z|A.*B|I.*J|K.*L|M.*N|Y|X" uk_words.out | wc -l` | bc
-	sed -r "s/[WZYXOP]|A.*B|I.*J|K.*L|M.*N/\n/g" uk_words.out | wc -l
+	sed -r "s/[ZYXW|]|A.*B|I.*J|K.*L|M.*N/\n/g" uk_words.out | wc -l
 
 sort:
 	@for ff in $(SORTED) ; do \

=== debian/changelog ===
ispell-uk (1.8.0+dfsg-1) unstable; urgency=medium

  * New upstream release
    - Sources repacked to remove files:
      - bin/tag/__pycache__ - binary files without source.
      - bin/tag/uk_words.out - symlink that points outside of the
        source tree.
  * New patches:
    - make-fixes.diff - fix build errors because of incorrect Makefile
    - remove-gzip-timestamp.diff - run gzip with -n to remove timestamp.
  * Remove ispell support - removed upstream
  * Add debian/salsa-ci.yml.
  * Trim trailing whitespace.
  * Update watch file format version to 4.
  * Bump debhelper from deprecated 7 to 13.
  * Set debhelper-compat version in Build-Depends.
  * Update Vcs-* headers to use salsa repository.
  * Use a resolvable URL for the Homepage field.
  * Don't generate the KOI8-U locale - it's unused.
  * Remove debian/gbp.conf — not needed anymore.
  * Simplify debin/rules using dh.
  * Change backage section to localization, keep section text for wukrainian.
  * Standards-Version 4.6.0
  * Point to versioned version of GPL and LGPL in debian/copyright.

 -- Євгеній Мещеряков <eugen@debian.org>  Wed, 27 Oct 2021 20:00:20 +0200

=== debian/control ===
--- 
+++ 
@@ -1,22 +1,15 @@
 Source: ispell-uk
-Section: text
+Section: localization
 Priority: optional
 Maintainer: Євгеній Мещеряков <eugen@debian.org>
-Build-Depends: debhelper (>= 7.0.0), dictionaries-common-dev (>= 1.22.4~), ispell (>= 3.3.02~), aspell (>= 0.60.3-3), locales (>> 2)
-Standards-Version: 3.9.5
-Homepage: http://ispell-uk.sourceforge.net
-Vcs-Git: git://git.debian.org/collab-maint/ispell-uk.git
-Vcs-Browser: http://git.debian.org/?p=collab-maint/ispell-uk.git
-
-Package: iukrainian
-Architecture: any
-Depends: ${ispell:Depends}, ${misc:Depends}
-Suggests: wukrainian
-Provides: ispell-dictionary
-Description: Ukrainian dictionary for ispell
- This is a Ukrainian dictionary, to be used with the ispell program.
+Build-Depends: debhelper-compat (= 13), dictionaries-common-dev (>= 1.22.4~), aspell (>= 0.60.3-3), locales (>> 2)
+Standards-Version: 4.6.0
+Homepage: https://sourceforge.net/projects/ispell-uk/
+Vcs-Git: https://salsa.debian.org/debian/ispell-uk.git
+Vcs-Browser: https://salsa.debian.org/debian/ispell-uk
 
 Package: wukrainian
+Section: text
 Architecture: all
 Depends: ${wordlist:Depends}, ${misc:Depends}
 Provides: wordlist

=== debian/watch ===
version=4
opts=dversionmangle=auto http://sf.net/ispell-uk .*/spell-uk-(.*)\.tgz
